/* tslint:disable */
/* eslint-disable */
/**
*/
export class PQueue {
  free(): void;
/**
* Construct a new priority queue.
* 
* If the `order` is "asc" then it's a ascending priority queue.
* If the `order` is "desc" then it's a descending priority queue.
* Otherwise, it throws a exception.
* @param {string} order
*/
  constructor(order: string);
/**
* Insert a key in the priority queue.
*
* The method assumes that there is no data associated with the inserted key.
* @param {number | undefined} key_op
*/
  insertK(key_op?: number): void;
/**
* Insert a key in the priority queue. `insertKV` stands for `insert key and value`.
*
* The `value` should be any data associated with the inserted key.
* @param {number | undefined} key_op
* @param {any} value
*/
  insertKV(key_op: number | undefined, value: any): void;
/**
* Pop from the queue the pair key/value with higher priority.
*
* Returns a array which the first element is the key.
* The returned array have the length 2 if the key has inserted with associated data.
* If the key has inserted without any associated data, it returns a array with a single element.
* @returns {Array<any>}
*/
  popKV(): Array<any>;
/**
* Pop from the queue the key with higher priority.
* @returns {number}
*/
  popK(): number;
/**
* Return the key with higher priority without remove it
* @returns {number}
*/
  topK(): number;
/**
* Return the pair key/value with higher priority without remove it
*
* Returns a array which the first element is the key.
* The returned array have the length 2 if the key has inserted with associated data.
* If the key has inserted without any associated data, it returns a array with a single element.
* @returns {Array<any>}
*/
  topKV(): Array<any>;
/**
* The number of keys in the queue.
*/
  readonly length: number;
}
